// Marta Fernandez Poyatos


//Dibujo donut

function dibujaDonut(datos){
    d3.select('#reconoceEnfermedad').selectAll('svg').remove();
    // Establecemos las dimensiones de los gráficos
    var width = 750
    height = 550
    margin = 50

    // Establecemos el radio del donut
    var radius = Math.min(width, height) / 2 - margin


    // Creamos el objeto svg en #reconoceEnfermedad
    var svg = d3.select("#reconoceEnfermedad")
        .append("svg")
        .attr("width", width)
        .attr("height", height)
        .append("g")
        .attr("transform", "translate(" + width / 2 + "," + height / 2 + ")");
    // Etiqueta que muestra el numero de personas que padece cada enfermedad
    var tooltip = d3.select("body")
        .append("div")
        .attr("class", "tooltip")
        .style("opacity",0)
        .style("border", "solid")
        .style("border-width", "2px")
        .style("border-radius", "5px")

    // Establecemos los colores
    var color = d3.scaleOrdinal()
        .domain(datos)
        .range(["#FF6F00", "#40FA4D"])
            

    // Establecemos las posiciones de cada grupo en el donut
    var pie = d3.pie()
        .value(function(d) {return d.value; })
    var data_ready = pie(d3.entries(datos))
    // Definimos las funciones que reciben el evento del movimiento del ratón  
    var mouseover = function(d) {
     
        d3.select(this)
        .style("stroke", "black")
        .style("opacity", 0.4);
        d3.selectAll(".bar").transition().duration(40).style("opacity",0.5);
        d3.selectAll("#"+d3.select(this).attr("id")).transition().duration(1)
        .style("opacity", 1)
        .attr("y",function(d){return y(d.value);})
        .attr("height",21);
 
        tooltip.transition()
        .duration(300)
        .style("opacity", 1);
     }
 
     var mousemove = function(d) {
 
       tooltip.selectAll("text").remove();
       tooltip.selectAll("br").remove();
       tooltip.style("left", (d3.event.pageX ) + "px")
       .style("top", (d3.event.pageY) + "px")
       tooltip.append("text").text(d.data.key+': '+(d.value));
     }
 
     var mouseleave = function(d) {
       tooltip
         .style("opacity", 0)
       d3.select(this)
         .style("stroke", "black")
         .style("opacity", 0.8)
     }

    // Dibujamos el donut
    svg
        .selectAll('#reconoceEnfermedad')
        .data(data_ready)
        .enter()
        .append('path')
        .attr('d', d3.arc()
            .innerRadius(100)   // Tamaño del agujero del donut
            .outerRadius(radius)
        )
        .attr('fill', function(d){ return(color(d.data.key)) })
        .on("mouseover", mouseover)//capturamos el movimiento del raton
        .on("mousemove", mousemove)
        .on("mouseleave", mouseleave)//capturamos la salida del raton
      
        .attr("stroke", "black")
        .style("stroke-width", "2px")
        

    var legend = d3.select("#leyendaDonut").append('svg')
        .attr("width",300)
        .attr("height",200)
        .append("g");
    //Rectangulos identificativos
    legend.append("rect")
        .attr("x",15)
        .attr("y",30)
        .attr("height",20)
        .attr("width",20)
        .attr("fill","#FF6F00");
    legend.append('rect')
        .attr("x",15)
        .attr("y",60)
        .attr("height",20)
        .attr("width",20)
        .attr("fill","#40FA4D");


    //Informacion para cada rectangulo
    legend.append("text")
        .attr("x",45)
        .attr("y",45)
        .attr("font-family", "sans-serif")
        .style("font-size", "15px")
        .text("Reconoce padecer la enfermedad");
    legend.append("text")
        .attr("x",45)
        .attr("y",75)
        .attr("font-family", "sans-serif")
        .style("font-size", "15px")
        .text("No reconoce padecer la enfermedad");


    legend.append("text")
        .attr("x",15)
        .attr("y",10)
        .attr("font-family", "sans-serif")
        .style("font-weight", "bold")
        .style("font-size", "15px")
        .text("Leyenda");

}



